#version 330 

uniform mat4 projectionMatrix;
uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 normalMatrix;

layout (location = 0) in vec3 inPosition; 
layout (location = 1) in vec4 inColor;
layout (location = 2) in vec3 inNormal;

smooth out vec4 theColor;
smooth out vec3 vNormal;


void main() 
{ 
	mat4 modelViewProjectionMatrix = projectionMatrix * viewMatrix * modelMatrix;
	gl_Position = modelViewProjectionMatrix * vec4(inPosition, 1.0);

	theColor = inColor; 
	
    vec4 resVector = normalMatrix * vec4(inNormal, 0.0); 
    vNormal = resVector.xyz;
}